var articles= [] ;
var monthNames = [ "jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec" ];
var sys = arbor.ParticleSystem(1000, 2000, 0.5) // create the system with sensible repulsion/stiffness/friction
var miny, maxy;

document.getElementById('progress_bar').className = 'loading';
var progress = document.querySelector('.percent');

function updateRelation(i){
    var percentLoaded = Math.round((i / articles.length) * 100);
    // Increase the progress bar length.
    if (percentLoaded < 100) {
      progress.style.width = percentLoaded + '%';
      progress.textContent = percentLoaded + '%';
    }

    console.log("i = " + i);
    new_cr = [];
    new_cr_idx = [];
    crs = articles[i].cr.split(';')
    //console.log(crs);
    for(var j = 0; j < crs.length; ++j){
        //console.log("j = " + j);
        cr = crs[j].split(','); // 0-au, 1-py, 2-j9
        //console.log(cr);
        if(cr.length < 3) continue;
        for(var k = 0; k < articles.length; ++k) if(k != i){
            //console.log("k = " + k);
            if(!($.trim(cr[0]).toLowerCase() == $.trim(articles[k].au.split(';')[0]).toLowerCase().replace(",", ""))){
                //console.log($.trim(articles[k].au.split(';')[0]));
                continue;
            }
            if(!($.trim(cr[1]) == $.trim(articles[k].py))) continue;
            if(!($.trim(cr[2]).toLowerCase()  == $.trim(articles[k].j9).toLowerCase())) continue;
            new_cr.push(crs[j]);
            new_cr_idx.push(k);
            articles[k].citedby.push(i);
            break;
        }
    }
    articles[i].ncr= new_cr;
    articles[i].ncr_idx = new_cr_idx;
}

function constructRelation(){
    var count = 0;
    var itID = setInterval(function(){
            if(count < articles.length)
                updateRelation(count++);
            else{
                clearInterval(itID);
                renderTimeCite();
            }
        }, 50);
}


function handleFileSelect(evt) {
    articles= [];
	var files = evt.target.files; // FileList object
	// files is a FileList of File objects. List some properties.
	var output = [];
	var reader = new FileReader();
    reader.onload = function(){
        filetext = $(this)[0].result;
        //$("#list").html($("#list").html() + $(this)[0].result);
        title = filetext.split('\n')[0].split('\t');
        idx_au = $.inArray("AU", title);
        idx_py = $.inArray("PY", title);
        idx_ti = $.inArray("TI", title);
        idx_cr = $.inArray("CR", title);
        idx_j9 = $.inArray("J9", title);
        idx_pd = $.inArray("PD", title);

        if(Math.min(idx_au, idx_py, idx_ti, idx_cr, idx_j9, idx_pd) >= 0){
            //$("#list").html($(this)[0].result.split('\n')[0].split('\t'));
            $.each(filetext.split('\n').slice(1), function(idx, ele){
                if(ele.length > 10){
                    ele = ele.split('\t');
                    articles.push( {id: articles.length, au: ele[idx_au], ti: ele[idx_ti], py: ele[idx_py], cr: ele[idx_cr], j9:ele[idx_j9], pd:ele[idx_pd], month: $.inArray( ele[idx_pd].slice(0,3).toLowerCase(), monthNames ) + 1, citedby:[]});
                    //console.log(ele[idx_cr]);
                    //$("#list").html( $("#list").html() + ele[idx_cr] );
                }
            });
        }
        $("#start").css('display', 'inline');
    }
	for (var i = 0, f; f = files[i]; i++) {
		console.log(f);
        reader.readAsText(f);
	}
}


$("#files").change(handleFileSelect);


  var Renderer = function(canvas, type){
    $(canvas).get(0).width =  $(canvas).width();
    $(canvas).get(0).height = $(canvas).height();
    var canvas = $(canvas).get(0)
    var ctx = canvas.getContext("2d");
    var gfx = arbor.Graphics(canvas)
    var particleSystem = null

  	// helpers for figuring out where to draw arrows (thanks springy.js)
  	var intersect_line_line = function(p1, p2, p3, p4)
  	{
  		var denom = ((p4.y - p3.y)*(p2.x - p1.x) - (p4.x - p3.x)*(p2.y - p1.y));
  		if (denom === 0) return false // lines are parallel
  		var ua = ((p4.x - p3.x)*(p1.y - p3.y) - (p4.y - p3.y)*(p1.x - p3.x)) / denom;
  		var ub = ((p2.x - p1.x)*(p1.y - p3.y) - (p2.y - p1.y)*(p1.x - p3.x)) / denom;

  		if (ua < 0 || ua > 1 || ub < 0 || ub > 1)  return false
  		return arbor.Point(p1.x + ua * (p2.x - p1.x), p1.y + ua * (p2.y - p1.y));
  	}

  	var intersect_line_box = function(p1, p2, boxTuple)
  	{
  	  var p3 = {x:boxTuple[0], y:boxTuple[1]},
      	  w = boxTuple[2],
      	  h = boxTuple[3]
  	  
  		var tl = {x: p3.x, y: p3.y};
  		var tr = {x: p3.x + w, y: p3.y};
  		var bl = {x: p3.x, y: p3.y + h};
  		var br = {x: p3.x + w, y: p3.y + h};

      return intersect_line_line(p1, p2, tl, tr) ||
             intersect_line_line(p1, p2, tr, br) ||
             intersect_line_line(p1, p2, br, bl) ||
             intersect_line_line(p1, p2, bl, tl) ||
             false
  	}
  	
  	
    var that = {
      //
      // the particle system will call the init function once, right before the
      // first frame is to be drawn. it's a good place to set up the canvas and
      // to pass the canvas size to the particle system
      //
      init:function(system){
        // save a reference to the particle system for use in the .redraw() loop
        particleSystem = system

        // inform the system of the screen dimensions so it can map coords for us.
        // if the canvas is ever resized, screenSize should be called again with
        // the new dimensions
        particleSystem.screenSize(canvas.width, canvas.height) 
        particleSystem.screenPadding(40) // leave an extra 20px of whitespace per side

        that.initMouseHandling()
      },
      
      // 
      // redraw will be called repeatedly during the run whenever the node positions
      // change. the new positions for the nodes can be accessed by looking at the
      // .p attribute of a given node. however the p.x & p.y values are in the coordinates
      // of the particle system rather than the screen. you can either map them to
      // the screen yourself, or use the convenience iterators .eachNode (and .eachEdge)
      // which allow you to step through the actual node objects but also pass an
      // x,y point in the screen's coordinate system
      // 

      redraw:function(){
        if (!particleSystem) return
                
        ctx.clearRect(0,0, canvas.width, canvas.height)
        var nodeBoxes = {}
        particleSystem.eachNode(function(node, pt){
          // node: {mass:#, p:{x,y}, name:"", data:{}}
          // pt:   {x:#, y:#}  node position in screen coords
          

          // determine the box size and round off the coords if we'll be 
          // drawing a text label (awful alignment jitter otherwise...)
          art = articles[node.name];
          node.p.y = 2000 -(parseInt(art.py) + art.month/ 12);
          var label = node.data.label||""
          var w = ctx.measureText(""+label).width + 10
          if (!(""+label).match(/^[ \t]*$/)){
            pt.x = Math.floor(pt.x)
            pt.y = Math.floor(pt.y)
          }else{
            label = null
          }
          // ctx.fillRect(pt.x-w/2, pt.y-10, w,20)
          sizefactor = node.data.size;
          w = w * sizefactor;
          h = 20 * sizefactor;

          if (node.data.shape=='dot'){
             nodeBoxes[node.name] = [pt.x-w/2, pt.y-w/2, w,w]
          }else{
            //nodeBoxes[node.name] = [pt.x-w/2, pt.y-11, w, 22]
            nodeBoxes[node.name] = [pt.x-w/2, pt.y - h/2- 1 , w, h-2]
          }
        })    			



        ctx.strokeStyle = "rgba(0,0,0, 0.2)"
        ctx.lineWidth = 1
        ctx.beginPath()
        particleSystem.eachEdge(function(edge, pt1, pt2){
          // edge: {source:Node, target:Node, length:#, data:{}}
          // pt1:  {x:#, y:#}  source position in screen coords
          // pt2:  {x:#, y:#}  target position in screen coords

          var weight = edge.data.weight
          var color = edge.data.color
          
          // trace(color)
          if (!color || (""+color).match(/^[ \t]*$/)) color = null

          // find the start point
          var tail = intersect_line_box(pt1, pt2, nodeBoxes[edge.source.name])
          var head = intersect_line_box(tail, pt2, nodeBoxes[edge.target.name])

          ctx.save() 
            ctx.beginPath()

            if (!isNaN(weight)) ctx.lineWidth = weight
            if (color) ctx.strokeStyle = color
            // if (color) trace(color)
            ctx.fillStyle = null
          
            ctx.moveTo(tail.x, tail.y)
            ctx.lineTo(head.x, head.y)
            ctx.stroke()
          ctx.restore()
          
          // draw an arrowhead if this is a -> style edge
          if (edge.data.directed){
            ctx.save()
              // move to the head position of the edge we just drew
              var wt = !isNaN(weight) ? parseFloat(weight) : ctx.lineWidth
              var arrowLength = 6 + wt
              var arrowWidth = 2 + wt
              ctx.fillStyle = (color) ? color : ctx.strokeStyle
              ctx.translate(head.x, head.y);
              ctx.rotate(Math.atan2(head.y - tail.y, head.x - tail.x));

              // delete some of the edge that's already there (so the point isn't hidden)
              ctx.clearRect(-arrowLength/2,-wt/2, arrowLength/2,wt)

              // draw the chevron
              ctx.beginPath();
              ctx.moveTo(-arrowLength, arrowWidth);
              ctx.lineTo(0, 0);
              ctx.lineTo(-arrowLength, -arrowWidth);
              ctx.lineTo(-arrowLength * 0.8, -0);
              ctx.closePath();
              ctx.fill();
            ctx.restore()
          }
        })
        particleSystem.eachNode(function(node, pt){
          // node: {mass:#, p:{x,y}, name:"", data:{}}
          // pt:   {x:#, y:#}  node position in screen coords
          

          // determine the box size and round off the coords if we'll be 
          // drawing a text label (awful alignment jitter otherwise...)
          art = articles[node.name];
          node.p.y = 2000 -(parseInt(art.py) + art.month/ 12.0);
          var label = node.data.label||""
          var w = ctx.measureText(""+label).width + 10
          if (!(""+label).match(/^[ \t]*$/)){
            pt.x = Math.floor(pt.x)
            pt.y = Math.floor(pt.y)
          }else{
            label = null
          }
          
          /* draw a rectangle centered at pt
          if (node.data.color) ctx.fillStyle = node.data.color
          // else ctx.fillStyle = "#d0d0d0"
          else ctx.fillStyle = "rgba(0,0,0,.2)"
          */
          if(node.data.isover == 1){
                if(node.data.selected == 2){
                    ctx.fillStyle = "rgba(255,100,0,.9)"
                }
                else if(node.data.selected == 1){
                    ctx.fillStyle = "rgba(0 ,100, 255,.9)"
                }
                else if(node.data.selected == 3){
                    ctx.fillStyle = "rgba(0 ,255, 0,.9)"
                }
                else ctx.fillStyle = "rgba(0,0,0,.9)"
          }
          else{
                if(node.data.selected == 2){
                    ctx.fillStyle = "rgba(255,100,0,.5)"
                }
                else if(node.data.selected == 1){
                    ctx.fillStyle = "rgba(0 ,100, 255,.5)"
                }
                else if(node.data.selected == 3){
                    ctx.fillStyle = "rgba(0 ,255, 0,.5)"
                }
                else ctx.fillStyle = "rgba(0,0,0,.5)"
          }
          if (node.data.color=='none') ctx.fillStyle = "white"
          
          sizefactor = node.data.size;
          w = w * sizefactor;
          h = 20 * sizefactor;
          
          // ctx.fillRect(pt.x-w/2, pt.y-10, w,20)
          if (node.data.shape=='dot'){
             gfx.oval(pt.x-w/2, pt.y-w/2, w,w, {fill:ctx.fillStyle})
             nodeBoxes[node.name] = [pt.x-w/2, pt.y-w/2, w,w]
          }else{
            gfx.rect(pt.x-w/2, pt.y- h/2, w,h , 4, {fill:ctx.fillStyle})
            nodeBoxes[node.name] = [pt.x-w/2, pt.y - h/2- 1 , w, h-2]
          }

          // w = Math.max(20,w)

          // draw the text
          if (label){
            ctx.font = "12px Helvetica"
            ctx.textAlign = "center"
            ctx.fillStyle = "white"
            if (node.data.color=='none') ctx.fillStyle = '#333333'
            ctx.fillText(label||"", pt.x, pt.y+4)
            ctx.fillText(label||"", pt.x, pt.y+4)
          }
        })    			



      },
      initMouseHandling:function(){
        // no-nonsense drag and drop (thanks springy.js)
      	selected = null;
      	nearest = null;
      	var dragged = null;
        var mouseoverID = -1;
        var selectedID = -1;
        var oldmass = 1


        var handler = {
            overed:function(e){
        		var pos = $(canvas).offset();
        		_mouseP = arbor.Point(e.pageX-pos.left, e.pageY-pos.top)
        		overed = particleSystem.nearest(_mouseP);

                var y = maxy + 0.6666 - (maxy - miny) * (e.pageY-pos.top) / $(this).height();
                $("#tooltip").html("YEAR:" + Math.floor(y));
                //console.log($(this).height());
                $("#tooltip").css("top", e.pageY);
                if(e.pageX + 200 > $(this).width()){
                    $("#tooltip").css("left", "10px");
                    $("#tooltip").css("right", "");
                }
                else if(e.pageX - 200 < 0){
                    $("#tooltip").css("left", "");
                    $("#tooltip").css("right", "10px");
                }
            
                if (overed.node !== null){
                    if(mouseoverID >= 0)sys.getNode(mouseoverID).data.isover = 0
                    mouseoverID = overed.node.name
                    art = articles[mouseoverID];
                    $("#info #over").html("<b>鼠标所在论文id: " + mouseoverID  + ": </b><br>标题: <a  target=\"_blank\" href=\"http://scholar.google.com/scholar?hl=en&q="  + art.ti + "\">"+art.ti+"</a><br>作者: " + art.au + "\n<br>发表时间: "  + art.py + " " + art.pd + "\n");
                    sys.getNode(mouseoverID).data.isover = 1;
                }
        		//return false
            },
          clicked:function(e){
        		var pos = $(canvas).offset();
        		_mouseP = arbor.Point(e.pageX-pos.left, e.pageY-pos.top)
        		selected = nearest = dragged = particleSystem.nearest(_mouseP);
            
            if (dragged.node !== null){
                dragged.node.fixed = true
//        		if  (selected.node !== null) dragged.node.tempMass = 10000
//
//
                for(var i = 0; i < articles.length; ++i)if(sys.getNode(i)){
                    sys.getNode(i).data.selected = 0;
                }
                dragged.node.data.selected = 2;

                /* 清除上次选择的结点的连线的颜色*/
                edgs = sys.getEdgesFrom(selectedID);
                for(var i = 0; i < edgs.length; ++i){
                    edgs[i].data.color = "";
                }
                edgs = sys.getEdgesTo(selectedID);
                for(var i = 0; i < edgs.length; ++i){
                    edgs[i].data.color = "";
                }
                /***************************/
                selectedID = dragged.node.name;

                art = articles[dragged.node.name];

                citenode = art.citedby;
                for(var i = 0; i < citenode.length; ++i)if(sys.getNode(citenode[i])){
                    sys.getNode(citenode[i]).data.selected = 1;
                }
                edgs = sys.getEdgesFrom(dragged.node.name);
                for(var i = 0; i < edgs.length; ++i){
                    edgs[i].data.color = "rgba(0 ,255, 0,.9)";
                }

                refnode = art.ncr_idx;
                for(var i = 0; i < refnode.length; ++i)if(sys.getNode(refnode[i])){
                    sys.getNode(refnode[i]).data.selected = 3;
                }
                edgs = sys.getEdgesTo(dragged.node.name);
                for(var i = 0; i < edgs.length; ++i){
                    edgs[i].data.color = "rgba(0 ,100, 255,.9)";
                }

                $("#info #selected").html("<br><b>已选论文id: " + dragged.node.name  + "</b> <a onclick='removeArticle("+dragged.node.name+");'>删除</a><br>标题: <a target=\"_blank\" href=\"http://scholar.google.com/scholar?hl=en&q="  + art.ti + "\">"+art.ti+"</a><br>作者: " + art.au + "\n<br>发表时间: "  + art.py + " " + art.pd + "\n");
            }
        		      		
            $(canvas).bind('mousemove', handler.dragged)
        		$(window).bind('mouseup', handler.dropped)
      		
        		return false
          },
          dragged:function(e){
            var old_nearest = nearest && nearest.node._id
        		var pos = $(canvas).offset();
        		var s = arbor.Point(e.pageX-pos.left, e.pageY-pos.top)

            if (!nearest) return
        		if (dragged !== null && dragged.node !== null){
              var p = particleSystem.fromScreen(s)
        			dragged.node.p.x = p.x//{x:p.x, y:p.y}
                  art = articles[dragged.node.name];
                    dragged.node.p.y = 2000 -(parseInt(art.py) + art.month/ 12.0);
//        			dragged.tempMass = 100000
        		}

            return false
        	},

          dropped:function(e){
            if (dragged===null || dragged.node===undefined) return
            if (dragged.node !== null) dragged.node.fixed = false
            dragged.node.tempMass = 1000
            dragged = null;
            selected = null
            $(canvas).unbind('mousemove', handler.dragged)
        		$(window).unbind('mouseup', handler.dropped)
            _mouseP = null
            return false
          }

          
        }
        
        $(canvas).mousedown(handler.clicked);
        $(canvas).mousemove(handler.overed);
      	
      },
    	
    }
    return that
  }    
 

 var _cnt = 0;
 function removeArticle(id){
        sys.pruneNode(id);
        for(var i = 0; i < articles[id].citedby.length; ++i){
            var c_id = articles[id].citedby[i];
            var index = articles[c_id].ncr_idx.indexOf(id);
            articles[c_id].ncr_idx.splice(index, 1);
            if(articles[c_id].ncr_idx.length == 0 && articles[c_id].citedby.length == 0){
                sys.pruneNode(c_id);
            }
        }
        for(var i = 0; i < articles[id].ncr_idx.length; ++i){
            var c_id = articles[id].ncr_idx[i];
            var index = articles[c_id].citedby.indexOf(id);
            articles[c_id].citedby.splice(index, 1);
            if(articles[c_id].ncr_idx.length == 0 && articles[c_id].citedby.length == 0){
                sys.pruneNode(c_id);
            }
        }
        articles[id].ncr_idx = [];
        articles[id].citedby = [];
 }

  function renderTimeCite(){
        maxy = 1000; miny = 3000;
        for(var i = 0; i < articles.length; ++i){
            maxy = Math.max(maxy, articles[i].py);
            miny = Math.min(miny, articles[i].py);
        }
        $("#viewport").height(Math.max((maxy - miny) * 200, 200) );

    sys.parameters({repulsion: 50000, stiffness: 20000, friction: 0.99, dt: 0.05, gravity: true, precision: 0.2});
    sys.fps(14);
    sys.renderer = Renderer("#viewport") // our newly created renderer will have its .init() method called shortly by sys...

    for(var i = 0; i < articles.length; ++i){
        cr = articles[i].ncr_idx;
        for(var j = 0; j < cr.length; ++j){
            sys.addEdge(i, cr[j], {type:"arrow",directed: true});
        }
    }
    maxct = 0.0;
    for(var i = 0; i < articles.length; ++i)if(sys.getNode(i)){
        maxct = Math.max(articles[i].citedby.length, maxct);
    }
    for(var i = 0; i < articles.length; ++i)if(sys.getNode(i)){
        sys.getNode(i).data.label = (i || "0");
        sys.getNode(i).data.size = Math.max(Math.min(3.0 * Math.pow(articles[i].citedby.length / maxct, 1 / 4) , 3.0), 1.0);
        //sys.getNode(i).p.y = -(parseInt(articles[i].py) + articles[i].month/ 12);
    }
    _cnt = 50;
    _pg = setInterval(function(){
        progress.style.width = (_cnt / 100) + '%';
        progress.textContent = (_cnt / 100) + '%';
        _cnt += 50;
        if(_cnt > 10000){
            clearInterval(_pg);
            progress.style.width = '100%';
            progress.textContent = '100%';
        }
        }
    , 50)
    setTimeout(function(){
        sys.parameters({dt: 0.0005,friction: 0.99,gravity: true,precision: 0.2,repulsion: 40000,stiffness: 10000})
    }, 5000);
    
  }

$('#stopmotion').tooltip('hide');
